//CDDF_Ehvert_Simpson_UselessRobot


#include <Servo.h>


//Declare Pins
#define micPin 11
#define echoPin 10
#define trigPin 9
#define weightPin 3
#define frontLegsPin 6
#define backLegsPin 5

//Declare Servos
Servo servoWeight;
Servo servoFrontLegs;
Servo servoBackLegs;


//Declare Variables
int weightAngle = 90;

int legAngle = 10;
bool standing = true;
int distThreshold = 5;

int rolls = 6;

int sound = 0;
int soundThreshold = 3;

long duration; 
int distance = 6;


//Setup Code
void setup() {
  
  //Declare all pins
  pinMode(micPin, INPUT);
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  pinMode(weightPin, OUTPUT);
  pinMode(frontLegsPin, OUTPUT); 
  pinMode(backLegsPin, OUTPUT);

  //Declare Servo Motors
  servoWeight.attach(weightPin);
  servoFrontLegs.attach(frontLegsPin);
  servoBackLegs.attach(backLegsPin);

  //Set Initial Servo Angles
  servoWeight.write(weightAngle);
  servoFrontLegs.write(legAngle);
  servoBackLegs.write(legAngle);
  
  //Begin Serial for Monitoring
  Serial.begin(9600);

  delay(6000);
  
}

//Run Code
void loop() {


  //delay(1000);
  //Serial.println(standing);
  
  
  //Read Values from Sound Sensor (Coarse)
  delay(5);
  int sound1 = digitalRead(micPin);
  delay(5);
  int sound2 = digitalRead(micPin);
  delay(5);
  int sound3 = digitalRead(micPin);    
  delay(5);
  int sound4 = digitalRead(micPin);
  delay(5);
  int sound5 = digitalRead(micPin);
  delay(5);
  int sound6 = digitalRead(micPin);
  delay(5);
  int sound7 = digitalRead(micPin);
  delay(5);
  int sound8 = digitalRead(micPin);      
  delay(5);
  int sound9 = digitalRead(micPin); 
  delay(5);
  int sound10 = digitalRead(micPin); 
  
  //Get the Total of all the Sound Values
  int averageSound = (sound1 + sound2 + sound3 + sound4 + sound5 + sound6 + sound7 + sound8 + sound9 + sound10);

  Serial.println(averageSound);
  
  
  // Ultrasonic sensore
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  // Sets the trigPin HIGH (ACTIVE) for 10 microseconds
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  // Reads the echoPin, returns the sound wave travel time in microseconds
  duration = pulseIn(echoPin, HIGH);
  
  // Calculating the distance
  distance = duration * 0.034 / 2; // Speed of sound wave divided by 2 (go and back)

  

  
  //If bool Standing is true, Fall When Spooked by Sound 
   if (standing) {
   
    if (averageSound > 3) {
     
      standing = false;
      
      //Rotate Legs Up
      for (legAngle = 10; legAngle < 90; legAngle +=1) {
        servoFrontLegs.write(legAngle);
        servoBackLegs.write(legAngle);
        delay(10);
        
      }
      
      // Rotate Weight to Roll
      for (weightAngle = 90; weightAngle <= 180; weightAngle +=1) {
        servoWeight.write(weightAngle);
        delay(1);
      }

      delay (1500);
      
      // Roll around for 'i' iterations
      for (rolls = 2; rolls > 0; rolls -=1){
        
        for (weightAngle = 180; weightAngle > 0; weightAngle -=1) {
          servoWeight.write(weightAngle);
          delay(3);  
        }

        delay(1500);

      
        for (weightAngle = 0; weightAngle < 180; weightAngle +=1) {
          servoWeight.write(weightAngle);
          delay(3);  
        }

        delay(1500);

        
      }
      

      //Move Weight Back to 0 to Prepare to Stand
      for (weightAngle = 180; weightAngle > 90; weightAngle -=1) {
        servoWeight.write(weightAngle);
        delay(3);
      }
      
      delay(10000);
      
    }    
      
    }


  //If bool Standing is false, Stand Up when Object is within Distance Threshold to Ultrasonic Sensor 
  if (standing != true) { 
    
    if (distance < distThreshold) {
    
      for (legAngle = 90; legAngle > 10; legAngle -=1) {
        servoFrontLegs.write(legAngle);
        servoBackLegs.write(legAngle);
        delay(15);
      }
      
      standing = true;

      delay(5000);
    }
      
  }

  }
